package com.bipt.intelligentapplicationorchestrationservice.gpu.event;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.springframework.context.ApplicationEvent;

import java.time.Clock;

@Getter
@Setter
public class CacheUpdateEvent extends ApplicationEvent {
    public enum OperationType{
        FULL_SYNC,
        INCREMENTAL_UPDATE,
        INVALIDATE
    }


    private OperationType operationType;
    private final String eventType;
    private final Long resourceId;
    private final Long timestamp;

    // 基础构造函数
    public CacheUpdateEvent(Object source, String eventType, Long resourceId) {
        super(source);  // 必须调用父类构造方法
        this.eventType = eventType;
        this.resourceId = resourceId;
        this.timestamp = System.currentTimeMillis();
    }
    public CacheUpdateEvent(Object source, String eventType, Long resourceId, Clock clock) {
        super(source);
        this.eventType = eventType;
        this.resourceId = resourceId;
        this.timestamp = clock.millis();  // 允许外部控制时间戳
    }

}
