package com.bipt.intelligentapplicationorchestrationservice.gpu.exception;

import com.bipt.intelligentapplicationorchestrationservice.gpu.model.enums.ErrorCodeEnum;
import lombok.Getter;

@Getter
public class PermissionDeniedException extends RuntimeException {
    private final Integer code;

    public String getMessage() {
        return message;
    }

    public Integer getCode() {
        return code;
    }

    private final String message;

    public PermissionDeniedException(ErrorCodeEnum errorCode) {
        super(errorCode.getMessage());
        this.code = errorCode.getCode();
        this.message = errorCode.getMessage();
    }

    public PermissionDeniedException(ErrorCodeEnum errorCode, String appendMessage) {
        super(errorCode.getMessage()+": "+appendMessage);
        this.code = errorCode.getCode();
        this.message = errorCode.getMessage()+": "+appendMessage;
    }

}
