package com.bipt.intelligentapplicationorchestrationservice.gpu.model.dto;

import lombok.Data;

import java.time.LocalDateTime;
import java.util.Date;

@Data
public class GpuResponseDTO {
    private Long id;
    private String GPUModel;
    private Integer GPUMemorySize;
    private String Ip;
    private LocalDateTime createTime;
    // Builder类
    public static class Builder {
        private Long id;
        private String model;
        private Integer memory;
        private String ip;
        private LocalDateTime createdTime;

        public Builder id(Long id) {
            this.id = id;
            return this;
        }

        public Builder model(String model) {
            this.model = model;
            return this;
        }

        public Builder memory(Integer memory) {
            this.memory = memory;
            return this;
        }

        public Builder ip(String ip) {
            this.ip = ip;
            return this;
        }

        public Builder createdTime(LocalDateTime createdTime) {
            this.createdTime = createdTime;
            return this;
        }
        public GpuResponseDTO build() {
            // 必填字段校验（如网页2的推荐）
            if (id == null) {
                throw new IllegalArgumentException("GPU ID必须填写");
            }
            return new GpuResponseDTO();
        }
    }
    public String getCreateTimeStr(){
        return "GPU创建时间：" + createTime.toString();
    }
}
