package com.bipt.intelligentapplicationorchestrationservice.gpu.model.entity;

import com.bipt.intelligentapplicationorchestrationservice.gpu.cache.RedisCacheService;
import jakarta.persistence.*;
import lombok.Setter;
import org.hibernate.annotations.CreationTimestamp;
import jakarta.validation.constraints.Pattern;

import java.time.LocalDateTime;
import java.util.Date;

@Setter
@Entity
@Table(name = "Gpu_Resource")
public class GpuResource {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long GPUId;

    @Column(nullable = false, length = 64)
    private String GPUModel;

    @Column(nullable = false)
    private Integer GPUMemorySize;

    @Column(name = "is_deleted", nullable = false)
    private Integer isDeleted = 0;

    public @Pattern(regexp = "^((25[0-5]|2[0-4]\\d|[01]?\\d\\d?)\\.){3}(25[0-5]|2[0-4]\\d|[01]?\\d\\d?)$") String getIp() {
        return Ip;
    }

    public Long getGPUId() {
        return GPUId;
    }

    public String getGPUModel() {
        return GPUModel;
    }

    public Integer getGPUMemorySize() {
        return GPUMemorySize;
    }

    public LocalDateTime getCreateTime() {
        return CreateTime;
    }

    public Boolean getIsDeleted() {
        return isDeleted != 0;
    }

    @Column(nullable = false, length = 15)
    @Pattern(regexp = "^((25[0-5]|2[0-4]\\d|[01]?\\d\\d?)\\.){3}(25[0-5]|2[0-4]\\d|[01]?\\d\\d?)$")
    private String Ip;

    @Column(updatable = false)
    @CreationTimestamp
    private LocalDateTime CreateTime;

    public GpuResource(Long Id, String Model, Integer MemorySize, String ip, LocalDateTime create_time) {
        this.GPUId = Id;
        this.GPUModel = Model;
        this.GPUMemorySize = MemorySize;
        this.Ip = ip;
        this.CreateTime = create_time;
    }

    public GpuResource() {}


}
